Summary:        Reference compositor for Wayland
Name:           weston
Version:        12.0.2
Release:        2%{?dist}
License:        BSD and CC-BY-SA
URL:            http://wayland.freedesktop.org/
Source0:        https://gitlab.freedesktop.org/wayland/%{name}/-/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc, gcc-c++, glib2-devel, libjpeg-turbo-devel, pam-devel
BuildRequires:  meson, 
BuildRequires:  pkgconfig(cairo) >= 1.10.0, pkgconfig(cairo-xcb), pkgconfig(colord) >= 0.1.27
BuildRequires:  pkgconfig(dbus-1) >= 1.6, pkgconfig(egl), pkgconfig(freerdp2)
BuildRequires:  pkgconfig(gbm) >= 10.2, pkgconfig(glesv2), pkgconfig(lcms2)
BuildRequires:  pkgconfig(libdrm) >= 2.4.30, pkgconfig(libevdev), pkgconfig(libinput) >= 0.8.0
BuildRequires:  pkgconfig(libpng), pkgconfig(libsystemd) >= 209, pkgconfig(libudev) >= 136
%ifarch aarch64 %{power64} x86_64
BuildRequires:  libunwind-devel
%endif
BuildRequires:  pkgconfig(libva) >= 0.34.0, pkgconfig(libva-drm) >= 0.34.0, pkgconfig(libwebp)
BuildRequires:  pkgconfig(libxml-2.0) >= 2.6, pkgconfig(mtdev) >= 1.1.0, pkgconfig(neatvnc)
BuildRequires:  pkgconfig(pangocairo), pkgconfig(pixman-1) >= 0.25.2, pkgconfig(wayland-client) >= 1.12.0
BuildRequires:  pkgconfig(wayland-cursor), pkgconfig(wayland-egl), pkgconfig(wayland-protocols) >= 1.24
BuildRequires:  pkgconfig(wayland-scanner), pkgconfig(wayland-server), pkgconfig(x11)
BuildRequires:  pkgconfig(x11-xcb), pkgconfig(xcb), pkgconfig(xcb-cursor)
BuildRequires:  pkgconfig(xcb-composite), pkgconfig(xcb-shm), pkgconfig(xcb-xfixes)
BuildRequires:  pkgconfig(xcb-xkb), pkgconfig(xcursor), pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(libpipewire-0.2)
BuildRequires:  poppler-devel, poppler-glib-devel, gstreamer1-devel, gstreamer1-plugins-base-devel
BuildRequires:  pipewire-devel, libseat-devel
BuildRequires:  libseat-devel

Requires:       %{name}-libs = %{version}-%{release}
Requires:       mesa-dri-drivers
ExcludeArch: loongarch64

%global apiver %(echo %version | cut -d"." -f1)

%description
Weston is the reference wayland compositor that can run on KMS, under X11
or under another compositor.

%package        libs
Summary:        Weston compositor libraries

%description    libs
This package contains Weston compositor libraries.

%package        demo
Summary:        Weston demo program files

%description    demo
This package contains Weston demo program files.

%package        devel
Summary:        Common headers for weston
License:        MIT
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-libs = %{version}-%{release}

%description    devel
Common headers for weston

%prep
%setup -q

%build
export LDFLAGS="%{?build_ldflags} -Wl,-z,undefs"
%meson
%meson_build

%install
%meson_install

%check


%files
%license COPYING
%doc README.md
%{_bindir}/weston
%{_bindir}/weston-debug
%{_bindir}/weston-screenshooter
%{_bindir}/weston-tablet
%{_bindir}/weston-terminal
%{_bindir}/wcap-decode
%dir %{_libdir}/weston
%{_libdir}/weston/desktop-shell.so
%{_libdir}/weston/fullscreen-shell.so
%{_libdir}/weston/hmi-controller.so
%{_libdir}/weston/ivi-shell.so
%{_libdir}/weston/screen-share.so
%{_libdir}/weston/systemd-notify.so
%{_libdir}/weston/kiosk-shell.so
%{_libdir}/weston/libexec_weston.so*
%{_libexecdir}/weston-*
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man7/*.7*
%dir %{_datadir}/weston
%{_datadir}/weston/*.png
%{_datadir}/weston/wayland.svg
%{_datadir}/wayland-sessions/weston.desktop
%config %{_sysconfdir}/pam.d/weston-remote-access

%files libs
%license COPYING
%dir %{_libdir}/libweston-%{apiver}
%{_libdir}/libweston-%{apiver}/color-lcms.so
%{_libdir}/libweston-%{apiver}/drm-backend.so
%{_libdir}/libweston-%{apiver}/gl-renderer.so
%{_libdir}/libweston-%{apiver}/headless-backend.so
%{_libdir}/libweston-%{apiver}/pipewire-backend.so
%{_libdir}/libweston-%{apiver}/pipewire-plugin.so
%{_libdir}/libweston-%{apiver}/remoting-plugin.so
%{_libdir}/libweston-%{apiver}/rdp-backend.so
%{_libdir}/libweston-%{apiver}/vnc-backend.so
%{_libdir}/libweston-%{apiver}/wayland-backend.so
%{_libdir}/libweston-%{apiver}/x11-backend.so
%{_libdir}/libweston-%{apiver}/xwayland.so
%{_libdir}/libweston-%{apiver}.so.0*

%files demo
%license COPYING
%{_bindir}/weston-calibrator
%{_bindir}/weston-clickdot
%{_bindir}/weston-cliptest
%{_bindir}/weston-confine
%{_bindir}/weston-dnd
%{_bindir}/weston-editor
%{_bindir}/weston-eventdemo
%{_bindir}/weston-flower
%{_bindir}/weston-fullscreen
%{_bindir}/weston-image
%{_bindir}/weston-multi-resource
%{_bindir}/weston-presentation-shm
%{_bindir}/weston-resizor
%{_bindir}/weston-scaler
%{_bindir}/weston-simple-damage
%{_bindir}/weston-content_protection
%{_bindir}/weston-simple-dmabuf-egl
%{_bindir}/weston-simple-dmabuf-feedback
%{_bindir}/weston-simple-dmabuf-v4l
%{_bindir}/weston-simple-egl
%{_bindir}/weston-simple-shm
%{_bindir}/weston-simple-touch
%{_bindir}/weston-smoke
%{_bindir}/weston-stacking
%{_bindir}/weston-subsurfaces
%{_bindir}/weston-touch-calibrator
%{_bindir}/weston-transformed

%files devel
%{_includedir}/libweston-%{apiver}/
%{_includedir}/weston/
%{_libdir}/pkgconfig/libweston-%{apiver}.pc
%{_libdir}/pkgconfig/weston.pc
%{_libdir}/libweston-%{apiver}.so
%{_datadir}/pkgconfig/libweston-%{apiver}-protocols.pc
%{_datadir}/libweston-%{apiver}/protocols/

%changelog
* Thu Jul 25 2024 Pengda Dou <doupengda@loongson.cn> - 12.0.2-2
- [Type] other
- [DESC] add loongarch64 to ExcludeArch

* Fri Nov 17 2023 Chair <chairou@tencent.com> - 12.0.2-1
- Init
